diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c olsrd-current/lib/bmf/src/NetworkInterfaces.c
--- olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c	2007-02-11 12:51:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/NetworkInterfaces.c	2007-04-22 19:40:38.000000000 +0200
@@ -35,12 +35,12 @@
  * Description: Functions to open and close sockets
  * Created    : 29 Jun 2006
  *
- * $Id: NetworkInterfaces.c,v 1.3 2007/02/11 11:51:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 #include "NetworkInterfaces.h"
 
 /* System includes */
+#include <stddef.h> /* NULL */
 #include <syslog.h> /* syslog() */
 #include <string.h> /* strerror(), strchr(), strcmp() */
 #include <errno.h> /* errno */
@@ -60,14 +60,18 @@
 #include "olsr.h" /* olsr_printf() */
 #include "defs.h" /* olsr_cnf */
 #include "local_hna_set.h" /* add_local_hna4_entry() */
+#include "link_set.h" /* get_link_set() */
+#include "lq_route.h" /* MIN_LINK_QUALITY */
+#include "tc_set.h" /* olsr_lookup_tc_entry(), olsr_tc_lookup_dst() */
 
 /* Plugin includes */
 #include "Packet.h" /* IFHWADDRLEN */
-#include "Bmf.h" /* PLUGIN_NAME */
+#include "Bmf.h" /* PLUGIN_NAME, MainAddressOf() */
 #include "Address.h" /* IsMulticast() */
 
 /* List of network interface objects used by BMF plugin */
 struct TBmfInterface* BmfInterfaces = NULL;
+struct TBmfInterface* LastBmfInterface = NULL;
 
 /* Highest-numbered open socket file descriptor. To be used as first
  * parameter in calls to select(...). */
@@ -89,10 +93,13 @@
  * used, and this variable will be set to TT_TUN. */
 enum TTunOrTap TunOrTap = TT_TUN;
 
-#define ETHERTUNTAPIPNOTSET 0
+/* The underlying mechanism to forward multicast packets. Either:
+ * - BM_BROADCAST: BMF uses the IP local broadcast as destination address
+ * - BM_UNICAST_PROMISCUOUS: BMF uses the IP address of the best neighbor as
+ *   destination address. The other neighbors listen promiscuously. */
+enum TBmfMechanism BmfMechanism = BM_BROADCAST;
 
-/* 10.255.255.253 in host byte order */
-#define ETHERTUNTAPDEFAULTIP 0x0AFFFFFD
+#define ETHERTUNTAPIPNOTSET 0
 
 /* The IP address of the BMF network interface in host byte order.
  * May be overruled by setting the plugin parameter "BmfInterfaceIp". */
@@ -104,7 +111,7 @@
 
 /* The IP broadcast address of the BMF network interface in host byte order.
  * May be overruled by setting the plugin parameter "BmfinterfaceIp". */
-u_int32_t EtherTunTapIpBroadcast = ETHERTUNTAPDEFAULTIP;
+u_int32_t EtherTunTapIpBroadcast = ETHERTUNTAPIPNOTSET;
 
 /* Whether or not the configuration has overruled the default IP
  * configuration of the EtherTunTap interface */
@@ -122,7 +129,7 @@
  * Input      : ifname - network interface name (e.g. "mybmf0")
  * Output     : none
  * Return     : fail (0) or success (1)
- * Data Used  : none
+ * Data Used  : EtherTunTapIfName
  * ------------------------------------------------------------------------- */
 int SetBmfInterfaceName(const char* ifname)
 {
@@ -161,10 +168,11 @@
  * Function   : SetBmfInterfaceIp
  * Description: Overrule the default IP address and prefix length
  *              ("10.255.255.253/30") of the EtherTunTap interface
- * Input      : ip - IP address, followed by '/' and prefix length
+ * Input      : ip - IP address string, followed by '/' and prefix length
  * Output     : none
  * Return     : fail (0) or success (1)
- * Data Used  : none
+ * Data Used  : EtherTunTapIp, EtherTunTapIpMask, EtherTunTapIpBroadcast,
+ *              TunTapIpOverruled
  * ------------------------------------------------------------------------- */
 int SetBmfInterfaceIp(const char* ip)
 {
@@ -251,6 +259,53 @@
   return 0;
 }
 
+/* -------------------------------------------------------------------------
+ * Function   : SetBmfMechanism
+ * Description: Overrule the default BMF mechanism to either BM_BROADCAST or
+ *              BM_UNICAST_PROMISCUOUS.
+ * Input      : mechanism - either "Broadcast" or "UnicastPromiscuous"
+ * Output     : none
+ * Return     : fail (0) or success (1)
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+int SetBmfMechanism(const char* mechanism)
+{
+  if (strcmp(mechanism, "Broadcast") == 0)
+  {
+    BmfMechanism = BM_BROADCAST;
+    return 1;
+  }
+  else if (strcmp(mechanism, "UnicastPromiscuous") == 0)
+  {
+    BmfMechanism = BM_UNICAST_PROMISCUOUS;
+    return 1;
+  }
+
+  /* Value not recognized */
+  return 0;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : AddDescriptorToInputSet
+ * Description: Add a socket descriptor to the global set of socket file descriptors
+ * Input      : skfd - socket file descriptor
+ * Output     : none
+ * Return     : none
+ * Data Used  : HighestSkfd, InputSet
+ * Notes      : Keeps track of the highest-numbered descriptor
+ * ------------------------------------------------------------------------- */
+static void AddDescriptorToInputSet(int skfd)
+{
+  /* Keep the highest-numbered descriptor */
+  if (skfd > HighestSkfd)
+  {
+    HighestSkfd = skfd;
+  }
+
+  /* Add descriptor to input set */
+  FD_SET(skfd, &InputSet);
+}
+
 /* To save the state of the IP spoof filter for the EtherTunTap interface */
 static char EthTapSpoofState = '1';
 
@@ -258,21 +313,19 @@
  * Function   : DeactivateSpoofFilter
  * Description: Deactivates the Linux anti-spoofing filter for the tuntap
  *              interface
- * Input      : tunTapName - name used for the tuntap interface (e.g. "tun0" or "tap1")
+ * Input      : none
  * Output     : none
  * Return     : fail (0) or success (1)
- * Data Used  : EthTapSpoofState
+ * Data Used  : EtherTunTapIfName, EthTapSpoofState
  * Notes      : Saves the current filter state for later restoring
  * ------------------------------------------------------------------------- */
-static int DeactivateSpoofFilter(const char* tunTapName)
+int DeactivateSpoofFilter(void)
 {
   FILE* procSpoof;
   char procFile[FILENAME_MAX];
 
-  assert(tunTapName != NULL);
-
   /* Generate the procfile name */
-  sprintf(procFile, "/proc/sys/net/ipv4/conf/%s/rp_filter", tunTapName);
+  sprintf(procFile, "/proc/sys/net/ipv4/conf/%s/rp_filter", EtherTunTapIfName);
 
   /* Open procfile for reading */
   procSpoof = fopen(procFile, "r");
@@ -319,20 +372,18 @@
  * Function   : RestoreSpoofFilter
  * Description: Restores the Linux anti-spoofing filter setting for the tuntap
  *              interface
- * Input      : tunTapName - name used for the tuntap interface (e.g. "tun0" or "tap1")
+ * Input      : none
  * Output     : none
  * Return     : none
- * Data Used  : EthTapSpoofState
+ * Data Used  : EtherTunTapIfName, EthTapSpoofState
  * ------------------------------------------------------------------------- */
-static void RestoreSpoofFilter(const char* tunTapName)
+void RestoreSpoofFilter(void)
 {
   FILE* procSpoof;
   char procFile[FILENAME_MAX];
 
-  assert(tunTapName != NULL);
-
   /* Generate the procfile name */
-  sprintf(procFile, "/proc/sys/net/ipv4/conf/%s/rp_filter", tunTapName);
+  sprintf(procFile, "/proc/sys/net/ipv4/conf/%s/rp_filter", EtherTunTapIfName);
 
   /* Open procfile for writing */
   procSpoof = fopen(procFile, "w");
@@ -349,6 +400,560 @@
   }
 }
 
+#ifndef USING_THALES_LINK_COST_ROUTING
+/* -------------------------------------------------------------------------
+ * Function   : CalcEtx
+ * Description: Calculate the Expected Transmission Count (ETX) value, based on
+ *              link loss fraction and inverse link loss fraction
+ * Input      : loss - link loss fraction
+ *              neigh_loss - inverse link loss fraction 
+ * Output     : none
+ * Return     : the ETX value
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+static float CalcEtx(float loss, float neigh_loss) 
+{
+  if (loss < MIN_LINK_QUALITY || neigh_loss < MIN_LINK_QUALITY)
+  {
+    return INFINITE_ETX;
+  }
+  else
+  {
+    return 1.0 / (loss * neigh_loss);
+  }
+}
+#endif /* USING_THALES_LINK_COST_ROUTING */
+
+/* -------------------------------------------------------------------------
+ * Function   : GetBestNeighbor
+ * Description: Get the best neighbor on an interface to send a BMF packet to
+ * Input      : intf - the network interface
+ *              source - the source IP address of the BMF packet 
+ *              forwardedBy - the IP address of the node that forwarded the BMF
+ *                packet
+ *              forwardedTo - the IP address of the node to which the BMF packet
+ *                was directed 
+ * Output     : nPossibleNeighbors - number of found possible neighbors
+ * Return     : the best neighbor, or NULL if none found
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+struct link_entry* GetBestNeighbor(
+  struct TBmfInterface* intf,
+  union olsr_ip_addr* source,
+  union olsr_ip_addr* forwardedBy,
+  union olsr_ip_addr* forwardedTo,
+  int* nPossibleNeighbors)
+{
+  /* handle the non-LQ case */
+
+  if (olsr_cnf->lq_level == 0)
+  {
+    struct link_entry* walker;
+    struct link_entry* bestLink = NULL;
+    *nPossibleNeighbors = 0;
+
+    /* TODO: get_link_set() is not thread-safe! */
+    for (walker = get_link_set(); walker != NULL; walker = walker->next) 
+    {
+      union olsr_ip_addr* neighborMainIp;
+
+      /* Consider only links from the specified interface */
+      if (! COMP_IP(&intf->intAddr, &walker->local_iface_addr))
+      {
+        continue; /* for */
+      }
+
+      OLSR_PRINTF(
+        8,
+        "%s: ----> Considering forwarding pkt on \"%s\" to %s\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName,
+        olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+      neighborMainIp = MainAddressOf(&walker->neighbor_iface_addr);
+
+      /* Consider only neighbors with an IP address that differs from the
+       * passed IP addresses (if passed). Rely on short-circuit boolean evaluation. */
+      if (source != NULL && COMP_IP(neighborMainIp, MainAddressOf(source)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is source of pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedBy != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedBy)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node that forwarded the pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedTo != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedTo)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node to which the pkt was forwarded\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Found a candidate neighbor to direct our packet to */
+
+      *nPossibleNeighbors += 1;
+
+      /* Remember the first found link */
+      if (bestLink == NULL)
+      {
+        bestLink = walker;
+      }
+
+    } /* for */
+
+    if (bestLink == NULL)
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName);
+    }
+    else
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
+        PLUGIN_NAME_SHORT,
+        *nPossibleNeighbors == 1 ? "(and only) " : "",
+        intf->ifName,
+        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
+    }
+
+    return bestLink;
+  }
+  /* handle the LQ case */
+  else
+  {
+#ifdef USING_THALES_LINK_COST_ROUTING
+
+    struct link_entry* walker;
+    struct link_entry* bestLink = NULL;
+    float previousLinkCost = INFINITE_COST;
+    float bestLinkCost = INFINITE_COST;
+    *nPossibleNeighbors = 0;
+
+    if (forwardedBy != NULL)
+    {
+      /* Retrieve the cost of the link from 'forwardedBy' to myself */
+      struct link_entry* bestLinkFromForwarder = get_best_link_to_neighbor(forwardedBy);
+      if (bestLinkFromForwarder != NULL)
+      {
+        previousLinkCost = bestLinkFromForwarder->link_cost;
+      }
+    }
+
+    /* TODO: get_link_set() is not thread-safe! */
+    for (walker = get_link_set(); walker != NULL; walker = walker->next) 
+    {
+      union olsr_ip_addr* neighborMainIp;
+      struct link_entry* bestLinkToNeighbor;
+      struct tc_entry* tcLastHop;
+
+      /* Consider only links from the specified interface */
+      if (! COMP_IP(&intf->intAddr, &walker->local_iface_addr))
+      {
+        continue; /* for */
+      }
+
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Considering forwarding pkt on \"%s\" to %s\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName,
+        olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+      neighborMainIp = MainAddressOf(&walker->neighbor_iface_addr);
+
+      /* Consider only neighbors with an IP address that differs from the
+       * passed IP addresses (if passed). Rely on short-circuit boolean evaluation. */
+      if (source != NULL && COMP_IP(neighborMainIp, MainAddressOf(source)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is source of pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedBy != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedBy)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node that forwarded the pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedTo != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedTo)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node to which the pkt was forwarded\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Found a candidate neighbor to direct our packet to */
+
+      /* Compare costs to check if the candidate neighbor is best reached via 'intf' */
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Forwarding pkt to %s will cost %5.2f\n",
+        PLUGIN_NAME_SHORT,
+        olsr_ip_to_string(&walker->neighbor_iface_addr),
+        walker->link_cost);
+
+      /* If the candidate neighbor is best reached via another interface, then skip 
+       * the candidate neighbor; the candidate neighbor has been / will be selected via that
+       * other interface.
+       * TODO: get_best_link_to_neighbor() is not thread-safe. */
+      bestLinkToNeighbor = get_best_link_to_neighbor(&walker->neighbor_iface_addr);
+
+      if (walker != bestLinkToNeighbor)
+      {
+        if (bestLinkToNeighbor == NULL)
+        {
+          OLSR_PRINTF(
+            9,
+            "%s: ----> Not forwarding to %s: no link found\n",
+            PLUGIN_NAME_SHORT,
+            olsr_ip_to_string(&walker->neighbor_iface_addr));
+        }
+        else
+        {
+          struct interface* bestIntf = if_ifwithaddr(&bestLinkToNeighbor->local_iface_addr);
+
+          OLSR_PRINTF(
+            9,
+            "%s: ----> Not forwarding to %s: \"%s\" gives a better link to this neighbor, costing %5.2f\n",
+            PLUGIN_NAME_SHORT,
+            olsr_ip_to_string(&walker->neighbor_iface_addr),
+            bestIntf->int_name,
+            bestLinkToNeighbor->link_cost);
+        }
+
+        continue; /* for */
+      }
+
+      if (forwardedBy != NULL)
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> 2-hop path from %s via me to %s will cost %5.2f\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(forwardedBy),
+          olsr_ip_to_string(&walker->neighbor_iface_addr),
+          previousLinkCost + walker->link_cost);
+      }
+
+      /* Check the topology table whether the 'forwardedBy' node is itself a direct
+       * neighbor of the candidate neighbor, at a lower cost than the 2-hop route
+       * via myself. If so, we do not need to forward the BMF packet to the candidate
+       * neighbor, because the 'forwardedBy' node will forward the packet. */
+      if (forwardedBy != NULL)
+      {
+        /* TODO: olsr_lookup_tc_entry() is not thread-safe. */
+        tcLastHop = olsr_lookup_tc_entry(MainAddressOf(forwardedBy));
+        if (tcLastHop != NULL)
+        {
+          struct topo_dst* tcDest;
+
+          /* TODO: olsr_tc_lookup_dst() is not thread-safe. */
+          tcDest = olsr_tc_lookup_dst(tcLastHop, MainAddressOf(&walker->neighbor_iface_addr));
+
+          /* Rely on short-circuit boolean evaluation */
+          if (tcDest != NULL && previousLinkCost + walker->link_cost > tcDest->link_cost)
+          {
+            OLSR_PRINTF(
+              9,
+              "%s: ----> Not forwarding to %s: I am not an MPR between %s and %s, direct link costs %5.2f\n",
+              PLUGIN_NAME_SHORT,
+              olsr_ip_to_string(&walker->neighbor_iface_addr),
+              olsr_ip_to_string(forwardedBy),
+              olsr_ip_to_string(&walker->neighbor_iface_addr),
+              tcDest->link_cost);
+
+            continue; /* for */
+          } /* if */
+        } /* if */
+      } /* if */
+
+      *nPossibleNeighbors += 1;
+
+      /* Remember the best link. If all are very bad, remember none. */
+      if (walker->link_cost < bestLinkCost)
+      {
+        bestLink = walker;
+        bestLinkCost = walker->link_cost;
+	    }
+    } /* for */
+
+    if (bestLink == NULL)
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName);
+    }
+    else
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
+        PLUGIN_NAME_SHORT,
+        *nPossibleNeighbors == 1 ? "(and only) " : "",
+        intf->ifName,
+        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
+    }
+
+    return bestLink;
+
+#else /* USING_THALES_LINK_COST_ROUTING */
+        
+    struct link_entry* walker;
+    struct link_entry* bestLink = NULL;
+    float previousLinkEtx = INFINITE_ETX;
+    float bestEtx = INFINITE_ETX; 
+    *nPossibleNeighbors = 0;
+
+    if (forwardedBy != NULL)
+    {
+      /* Retrieve the cost of the link from 'forwardedBy' to myself */
+      struct link_entry* bestLinkFromForwarder = get_best_link_to_neighbor(forwardedBy);
+      if (bestLinkFromForwarder != NULL)
+      {
+        previousLinkEtx =
+          CalcEtx(
+            bestLinkFromForwarder->loss_link_quality,
+            bestLinkFromForwarder->neigh_link_quality);
+      }
+    }
+
+    /* TODO: get_link_set() is not thread-safe! */
+    for (walker = get_link_set(); walker != NULL; walker = walker->next) 
+    {
+      union olsr_ip_addr* neighborMainIp;
+      struct link_entry* bestLinkToNeighbor;
+      struct tc_entry* tcLastHop;
+      float currEtx;
+ 
+      /* Consider only links from the specified interface */
+      if (! COMP_IP(&intf->intAddr, &walker->local_iface_addr))
+      {
+        continue; /* for */
+      }
+
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Considering forwarding pkt on \"%s\" to %s\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName,
+        olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+      neighborMainIp = MainAddressOf(&walker->neighbor_iface_addr);
+
+      /* Consider only neighbors with an IP address that differs from the
+       * passed IP addresses (if passed). Rely on short-circuit boolean evaluation. */
+      if (source != NULL && COMP_IP(neighborMainIp, MainAddressOf(source)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is source of pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedBy != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedBy)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node that forwarded the pkt\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Rely on short-circuit boolean evaluation */
+      if (forwardedTo != NULL && COMP_IP(neighborMainIp, MainAddressOf(forwardedTo)))
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> Not forwarding to %s: is the node to which the pkt was forwarded\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(&walker->neighbor_iface_addr));
+
+        continue; /* for */
+      }
+
+      /* Found a candidate neighbor to direct our packet to */
+
+      /* Calculate the link quality (ETX) of the link to the found neighbor */
+      currEtx = CalcEtx(
+        walker->loss_link_quality,
+        walker->neigh_link_quality);
+ 
+      /* Compare costs to check if the candidate neighbor is best reached via 'intf' */
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Forwarding pkt to %s will cost ETX %5.2f\n",
+        PLUGIN_NAME_SHORT,
+        olsr_ip_to_string(&walker->neighbor_iface_addr),
+        currEtx);
+
+      /* If the candidate neighbor is best reached via another interface, then skip 
+       * the candidate neighbor; the candidate neighbor has been / will be selected via that
+       * other interface.
+       * TODO: get_best_link_to_neighbor() is not thread-safe. */
+      bestLinkToNeighbor = get_best_link_to_neighbor(&walker->neighbor_iface_addr);
+
+      if (walker != bestLinkToNeighbor)
+      {
+        if (bestLinkToNeighbor == NULL)
+        {
+          OLSR_PRINTF(
+            9,
+            "%s: ----> Not forwarding to %s: no link found\n",
+            PLUGIN_NAME_SHORT,
+            olsr_ip_to_string(&walker->neighbor_iface_addr));
+        }
+        else
+        {
+          struct interface* bestIntf = if_ifwithaddr(&bestLinkToNeighbor->local_iface_addr);
+
+          OLSR_PRINTF(
+            9,
+            "%s: ----> Not forwarding to %s: \"%s\" gives a better link to this neighbor, costing %5.2f\n",
+            PLUGIN_NAME_SHORT,
+            olsr_ip_to_string(&walker->neighbor_iface_addr),
+            bestIntf->int_name,
+            CalcEtx(
+              bestLinkToNeighbor->loss_link_quality,
+              bestLinkToNeighbor->neigh_link_quality));
+        }
+
+        continue; /* for */
+      }
+
+      if (forwardedBy != NULL)
+      {
+        OLSR_PRINTF(
+          9,
+          "%s: ----> 2-hop path from %s via me to %s will cost ETX %5.2f\n",
+          PLUGIN_NAME_SHORT,
+          olsr_ip_to_string(forwardedBy),
+          olsr_ip_to_string(&walker->neighbor_iface_addr),
+          previousLinkEtx + currEtx);
+      }
+
+      /* Check the topology table whether the 'forwardedBy' node is itself a direct
+       * neighbor of the candidate neighbor, at a lower cost than the 2-hop route
+       * via myself. If so, we do not need to forward the BMF packet to the candidate
+       * neighbor, because the 'forwardedBy' node will forward the packet. */
+      if (forwardedBy != NULL)
+      {
+        /* TODO: olsr_lookup_tc_entry() is not thread-safe. */
+        tcLastHop = olsr_lookup_tc_entry(MainAddressOf(forwardedBy));
+        if (tcLastHop != NULL)
+        {
+          struct topo_dst* tcDest;
+
+          /* TODO: olsr_tc_lookup_dst() is not thread-safe. */
+          tcDest = olsr_tc_lookup_dst(tcLastHop, MainAddressOf(&walker->neighbor_iface_addr));
+
+          if (tcDest != NULL)
+          {
+            float tcEtx = CalcEtx(
+              tcDest->link_quality,
+              tcDest->inverse_link_quality);
+
+            if (previousLinkEtx + currEtx > tcEtx)
+            {
+              OLSR_PRINTF(
+                9,
+                "%s: ----> Not forwarding to %s: I am not an MPR between %s and %s, direct link costs %5.2f\n",
+                PLUGIN_NAME_SHORT,
+                olsr_ip_to_string(&walker->neighbor_iface_addr),
+                olsr_ip_to_string(forwardedBy),
+                olsr_ip_to_string(&walker->neighbor_iface_addr),
+                tcEtx);
+
+              continue; /* for */
+            } /* if */
+          } /* if */
+        } /* if */
+      } /* if */
+
+      *nPossibleNeighbors += 1;
+
+      /* Remember the best link. If all are very bad, remember none. */
+      if (currEtx < bestEtx)
+      {
+        bestLink = walker;
+        bestEtx = currEtx;
+      }
+
+    } /* for */
+
+    if (bestLink == NULL)
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
+        PLUGIN_NAME_SHORT,
+        intf->ifName);
+    }
+    else
+    {
+      OLSR_PRINTF(
+        9,
+        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
+        PLUGIN_NAME_SHORT,
+        *nPossibleNeighbors == 1 ? "(and only) " : "",
+        intf->ifName,
+        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
+    }
+
+    return bestLink;
+
+#endif /* USING_THALES_LINK_COST_ROUTING */
+
+  } /* if */
+} /* GetBestNeighbor */
+
 /* -------------------------------------------------------------------------
  * Function   : CreateCaptureSocket
  * Description: Create socket for promiscuously capturing multicast IP traffic
@@ -370,7 +975,7 @@
   int skfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
   if (skfd < 0)
   {
-    olsr_printf(1, "%s: socket(PF_PACKET) error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("socket(PF_PACKET) error");
     return -1;
   }
 
@@ -380,7 +985,7 @@
   mreq.mr_type = PACKET_MR_PROMISC;
   if (setsockopt(skfd, SOL_PACKET, PACKET_ADD_MEMBERSHIP, &mreq, sizeof(mreq)) < 0)
   {
-    olsr_printf(1, "%s: setsockopt(PACKET_MR_PROMISC) error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("setsockopt(PACKET_MR_PROMISC) error");
     close(skfd);
     return -1;
   }
@@ -391,22 +996,22 @@
   req.ifr_name[IFNAMSIZ-1] = '\0'; /* Ensures null termination */
   if (ioctl(skfd, SIOCGIFHWADDR, &req) < 0)
   {
-    olsr_printf(1, "%s: error retrieving MAC address: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("error retrieving MAC address");
     close(skfd);
     return -1;
   }
    
   /* Bind the socket to the specified interface */
   memset(&bindTo, 0, sizeof(bindTo));
+  bindTo.sll_family = AF_PACKET;
   bindTo.sll_protocol = htons(ETH_P_ALL);
   bindTo.sll_ifindex = ifIndex;
-  bindTo.sll_family = AF_PACKET;
   memcpy(bindTo.sll_addr, req.ifr_hwaddr.sa_data, IFHWADDRLEN);
   bindTo.sll_halen = IFHWADDRLEN;
     
   if (bind(skfd, (struct sockaddr*)&bindTo, sizeof(bindTo)) < 0)
   {
-    olsr_printf(1, "%s: bind() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("bind() error");
     close(skfd);
     return -1;
   }
@@ -414,19 +1019,88 @@
   /* Set socket to blocking operation */
   if (fcntl(skfd, F_SETFL, fcntl(skfd, F_GETFL, 0) & ~O_NONBLOCK) < 0)
   {
-    olsr_printf(1, "%s: fcntl() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("fcntl() error");
     close(skfd);
     return -1;
   }
 
-  /* Keep the highest-numbered descriptor */
-  if (skfd > HighestSkfd)
+  AddDescriptorToInputSet(skfd);
+
+  return skfd;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : CreateListeningSocket
+ * Description: Create socket for promiscuously listening to BMF packets.
+ *              Used when 'BmfMechanism' is BM_UNICAST_PROMISCUOUS
+ * Input      : ifname - network interface (e.g. "eth0")
+ * Output     : none
+ * Return     : the socket descriptor ( >= 0), or -1 if an error occurred
+ * Data Used  : none
+ * Notes      : The socket is an UDP (datagram) packet socket, bound to the specified
+ *              network interface
+ * ------------------------------------------------------------------------- */
+static int CreateListeningSocket(const char* ifName)
+{
+  int ifIndex = if_nametoindex(ifName);
+  struct packet_mreq mreq;
+  struct ifreq req;
+  struct sockaddr_ll bindTo;
+
+  /* Open UDP packet socket */
+  int skfd = socket(PF_PACKET, SOCK_DGRAM, 0);
+  if (skfd < 0)
   {
-    HighestSkfd = skfd;
+    BmfPError("socket(PF_PACKET) error");
+    return -1;
   }
 
-  /* Add descriptor to input set */
-  FD_SET(skfd, &InputSet);
+  /* Set interface to promiscuous mode */
+  memset(&mreq, 0, sizeof(struct packet_mreq));
+  mreq.mr_ifindex = ifIndex;
+  mreq.mr_type = PACKET_MR_PROMISC;
+  if (setsockopt(skfd, SOL_PACKET, PACKET_ADD_MEMBERSHIP, &mreq, sizeof(mreq)) < 0)
+  {
+    BmfPError("setsockopt(PACKET_MR_PROMISC) error");
+    close(skfd);
+    return -1;
+  }
+
+  /* Get hardware (MAC) address */
+  memset(&req, 0, sizeof(struct ifreq));
+  strncpy(req.ifr_name, ifName, IFNAMSIZ - 1);
+  req.ifr_name[IFNAMSIZ-1] = '\0'; /* Ensures null termination */
+  if (ioctl(skfd, SIOCGIFHWADDR, &req) < 0)
+  {
+    BmfPError("error retrieving MAC address");
+    close(skfd);
+    return -1;
+  }
+   
+  /* Bind the socket to the specified interface */
+  memset(&bindTo, 0, sizeof(bindTo));
+  bindTo.sll_family = AF_PACKET;
+  bindTo.sll_protocol = htons(ETH_P_ALL);
+  bindTo.sll_ifindex = ifIndex;
+  memcpy(bindTo.sll_addr, req.ifr_hwaddr.sa_data, IFHWADDRLEN);
+  bindTo.sll_halen = IFHWADDRLEN;
+    
+  if (bind(skfd, (struct sockaddr*)&bindTo, sizeof(bindTo)) < 0)
+  {
+    BmfPError("bind() error");
+    close(skfd);
+    return -1;
+  }
+
+  /* Set socket to blocking operation */
+  if (fcntl(skfd, F_SETFL, fcntl(skfd, F_GETFL, 0) & ~O_NONBLOCK) < 0)
+  {
+    BmfPError("fcntl() error");
+    close(skfd);
+    return -1;
+  }
+
+  AddDescriptorToInputSet(skfd);
 
   return skfd;
 }
@@ -451,14 +1125,14 @@
   int skfd = socket(PF_INET, SOCK_DGRAM, 0);
   if (skfd < 0)
   {
-    olsr_printf(1, "%s: socket(PF_INET) error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("socket(PF_INET) error");
     return -1;
   }
 
   /* Enable sending to broadcast addresses */
   if (setsockopt(skfd, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on)) < 0)
   {
-    olsr_printf(1, "%s: setsockopt() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("setsockopt(SO_BROADCAST) error");
     close(skfd);
     return -1;
   }
@@ -467,12 +1141,12 @@
   /* When using Kernel 2.6 this must happer prior to the port binding! */
   if (setsockopt(skfd, SOL_SOCKET, SO_BINDTODEVICE, ifName, strlen(ifName) + 1) < 0)
   {
-    olsr_printf(1, "%s: setsockopt() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("setsockopt(SO_BINDTODEVICE) error");
     close(skfd);
     return -1;
   }
 
-  /* Bind to port */
+  /* Bind to BMF port */
   memset(&bindTo, 0, sizeof(bindTo));
   bindTo.sin_family = AF_INET;
   bindTo.sin_port = htons(BMF_ENCAP_PORT);
@@ -480,7 +1154,7 @@
       
   if (bind(skfd, (struct sockaddr*)&bindTo, sizeof(bindTo)) < 0) 
   {
-    olsr_printf(1, "%s: bind() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("bind() error");
     close(skfd);
     return -1;
   }
